module.exports = async ctx => {
    const { action, params } = ctx.args
    switch (action) {
        // 获取相册列表
        case 'ListAlbum': {
            const { result } = await ctx.mpserverless.db.collection('album').find()
            return result
        }
        // 创建相册
        case 'AddAlbum': {
            const { result } = await ctx.mpserverless.db.collection('album').findOneAndReplace(
                { album: params.album },
                { album: params.album },
                { upsert: true }
            )
            return result
        }
        // 获取图片列表
        case 'ListPhoto': {
            const { result } = await ctx.mpserverless.db.collection('photo').find({album: params.album})
            return result
        }
        // 上传图片
        case 'AddPhoto': {
            const { result } =  await ctx.mpserverless.db.collection('photo').insertOne(params)
            return result
        }
        // 获取壁纸推荐
        case 'ListWallpaper': {
            const { result } =  await ctx.mpserverless.db.collection('wallpaper').find({},
                {
                    limit: 100,
                    sort: { date: -1 },
                    maxTimeMS: 3000
                }
            )
            return result
        }
        // 收藏壁纸
        case 'Collect': {
            // 如果不存在相册"我的收藏"则插入
            await ctx.mpserverless.db.collection('album').findOneAndReplace(
                { album: '我的收藏' },
                { album: '我的收藏' },
                { upsert: true }
            )
            // 更新壁纸收藏标志
            await ctx.mpserverless.db.collection('wallpaper').findOneAndUpdate(
                { url: params.url },
                { $set : { collected: true } }
            )
            // 插入相册"我的收藏"
            params.album = '我的收藏'
            const { result } =  await ctx.mpserverless.db.collection('photo').insertOne(params)
            return result
        }
    }
}